--[[

	SlammerBall v0.1
	____________________________________________
	Programming: MasterQ
	Graphics: MasterQ
	Sounds/Music: MasterQ
	Copyright  2005 MasterQ. All Rights Reserved.

]]

-- play background music
Music.playFile("sounds/music.xm", true)

-- load images
background = Image.load("images/bg.png")
bgoverlay = Image.load("images/overlay.png")
ball = Image.load("images/ball.png")
target = Image.load("images/target.png")

-- define variables
blue1 = Color.new(0, 102, 200)
blue2 = Color.new(0, 185, 250)
white = Color.new(255, 255, 255)
targetpos = 1
lasttargetpos = 0
target_x = 7
target_y = 7
ball_x = 228
ball_y = 124
move_x = 0
move_y = 0
score = 0
highscore = 0
level = 0
menuitem = 0
menuchange = 0
screenid = 0
go = 0
state = 0
statechange = 0

-- check for buttons being pressed
function keyboardControl()
	screen.waitVblankStart()
	pad = Controls.read()

	if screenid == 0 then -- Main Menu
		if pad:up() then
			if menuchange == 0 then
				if menuitem > 0 then
					menuitem = menuitem - 1
					menuchange = 1
				end
			end
		elseif pad:down() then
			if menuchange == 0 then
				if menuitem < 1 then
					menuitem = menuitem + 1
					menuchange = 1
				end
			end
		elseif pad:cross() then
			go = 1
		end
	elseif screenid == 1 then -- Game
		if pad:up() and state == 0 then
			move_x = 0
			move_y = -12
		elseif pad:down() and state == 0 then
			move_x = 0
			move_y = 12
		elseif pad:left() and state == 0 then
			move_x = -12
			move_y = 0
		elseif pad:right() and state == 0 then
			move_x = 12
			move_y = 0
		elseif pad:r() then
			newgame()
		elseif pad:l() then
			screenid = 0
			newgame()
		elseif pad:cross() and state == 2 then
			if statechange == 0 then
				if state == 2 then
					newgame()
					state = 0
					statechange = 1
				end
			end
		elseif pad:start() then
			if statechange == 0 then
				if state == 0 then
					state = 1
					statechange = 1
				elseif state == 1 then
					state = 0
					statechange = 1
				end
			end
		end
	elseif screenid == 2 then --About Screen
		if pad:circle() then
			screenid = 0
		end
	end

end

-- set the new coordinates of the ball
function move()
	ball_x = ball_x + move_x
	ball_y = ball_y + move_y
end

-- start a new game
function newgame()
	move_x = 0
	move_y = 0
	ball_x = 228
	ball_y = 124
	settarget()
	score = 0
	state = 0
end

-- draw the images on the screen
function drawgame()
	screen:blit(0, 0, background)
	screen:blit(target_x, target_y, target)
	screen:blit(ball_x, ball_y, ball)
	screen:fillRect(57, 57, 40, 5, blue2) -- Line 1
	screen:fillRect(57, 57, 5, 40, blue2) -- Line 2
	screen:fillRect(57, 160, 5, 40, blue2) -- Line 3
	screen:fillRect(57, 195, 40, 5, blue2) -- Line 4
	screen:fillRect(127, 107, 5, 43, blue2) -- Line 5
	screen:fillRect(348, 107, 5, 43, blue2) -- Line 6
	screen:fillRect(172, 57, 136, 5, blue2) -- Line 7
	screen:fillRect(172, 195, 136, 5, blue2) -- Line 8
	screen:fillRect(383, 57, 40, 5, blue2) -- Line 9
	screen:fillRect(418, 57, 5, 40, blue2) -- Line 10
	screen:fillRect(383, 195, 40, 5, blue2) -- Line 11
	screen:fillRect(418, 160, 5, 40, blue2) -- Line 12
	screen:fillRect(7, 92, 55, 5, blue2) -- Line 13
	screen:fillRect(92, 195, 5, 55, blue2) -- Line 14
	screen:fillRect(418, 160, 55, 5, blue2) -- Line 15
	screen:fillRect(383, 7, 5, 55, blue2) -- Line 16
	screen:blit(0, 0, bgoverlay)
	screen:print(6, 259, "Score: "..score, blue1)
	-- screen:print(110, 259, "High Score: "..highscore, blue1) -- High score will be fully implemented in a future version
end

function gameover()
	statechange = 1
	state = 2
end

function checkcollisions()

	if (ball_x + 24) > 57 then -- Check if ball collides with Line 1
		if ball_x < 97 then
			if ball_y < 62 then
				if (ball_y + 24) > 57 then
                    				gameover()
                				end
			end
		end
	end

	if (ball_x + 24) > 57 then -- Check if ball collides with Line 2
		if ball_x < 62 then
			if ball_y < 97 then
				if (ball_y + 24) > 57 then
					gameover()
                				end
			end
		end
	end

	if (ball_x + 24) > 57 then -- Check if ball collides with Line 3
		if ball_x < 62 then
			if ball_y < 200 then
				if (ball_y + 24) > 160 then
					gameover()
                				end
			end
		end
	end

	if (ball_x + 24) > 57 then -- Check if ball collides with Line 4
		if ball_x < 97 then
			if ball_y < 200 then
				if (ball_y + 24) > 195 then
                    				gameover()
                				end
			end
		end
	end

	if (ball_x + 24) > 127 then -- Check if ball collides with Line 5
		if ball_x < 132 then
			if ball_y < 150 then
				if (ball_y + 24) > 107 then
                    				gameover()
                				end
			end
		end
	end

	if (ball_x + 24) > 348 then -- Check if ball collides with Line 6
		if ball_x < 353 then
			if ball_y < 150 then
				if (ball_y + 24) > 107 then
                    				gameover()
                				end
			end
		end
	end

	if (ball_x + 24) > 172 then -- Check if ball collides with Line 7
		if ball_x < 308 then
			if ball_y < 62 then
				if (ball_y + 24) > 57 then
                    				gameover()
                				end
			end
		end
	end

	if (ball_x + 24) > 172 then -- Check if ball collides with Line 8
		if ball_x < 308 then
			if ball_y < 200 then
				if (ball_y + 24) > 195 then
                    				gameover()
                				end
			end
		end
	end

	if (ball_x + 24) > 383 then -- Check if ball collides with Line 9
		if ball_x < 423 then
			if ball_y < 62 then
				if (ball_y + 24) > 57 then
                    				gameover()
                				end
			end
		end
	end

	if (ball_x + 24) > 418 then -- Check if ball collides with Line 10
		if ball_x < 423 then
			if ball_y < 97 then
				if (ball_y + 24) > 57 then
                    				gameover()
                				end
			end
		end
	end

	if (ball_x + 24) > 383 then -- Check if ball collides with Line 11
		if ball_x < 423 then
			if ball_y < 200 then
				if (ball_y + 24) > 195 then
                    				gameover()
                				end
			end
		end
	end

	if (ball_x + 24) > 418 then -- Check if ball collides with Line 12
		if ball_x < 423 then
			if ball_y < 200 then
				if (ball_y + 24) > 160 then
                    				gameover()
                				end
			end
		end
	end

	if (ball_x + 24) > 7 then -- Check if ball collides with Line 13
		if ball_x < 62 then
			if ball_y < 97 then
				if (ball_y + 24) > 92 then
                    				gameover()
                				end
			end
		end
	end

	if (ball_x + 24) > 92 then -- Check if ball collides with Line 14
		if ball_x < 97 then
			if ball_y < 250 then
				if (ball_y + 24) > 195 then
                    				gameover()
                				end
			end
		end
	end

	if (ball_x + 24) > 418 then -- Check if ball collides with Line 15
		if ball_x < 473 then
			if ball_y < 165 then
				if (ball_y + 24) > 160 then
                    				gameover()
                				end
			end
		end
	end

	if (ball_x + 24) > 383 then -- Check if ball collides with Line 16
		if ball_x < 388 then
			if ball_y < 62 then
				if (ball_y + 24) > 7 then
                    				gameover()
                				end
			end
		end
	end

	if ball_y < 8 then -- Check if ball collides with Top Wall
		gameover()
	end
	
	if (ball_y + 24) > 250 then -- Check if ball collides with Bottom Wall
		gameover()
	end

	if ball_x < 8 then -- Check if ball collides with Left Wall
		gameover()
	end

	if (ball_x + 24) > 473 then -- Check if ball collides with Right Wall
		gameover()
	end

	if (ball_x + 24) > target_x then -- Check if ball collides with Target
		if ball_x < (target_x + 24) then
			if ball_y < (target_y + 24) then
				if (ball_y + 24) > target_y then
					settarget()
                    				score = score + 5
                				end
			end
		end
	end

end

function settarget()
	math.randomseed(os.time())
	while targetpos == lasttargetpos do
		targetpos = math.random(1, 10)
	end
	if targetpos == 1 then
		target_x = 20
		target_y= 57
		lasttargetpos = 1
	elseif targetpos == 2 then
		target_x = 208
		target_y= 20
		lasttargetpos = 2
	elseif targetpos == 3 then
		target_x = 399
		target_y= 20
		lasttargetpos = 3
	elseif targetpos == 4 then
		target_x = 93
		target_y= 116
		lasttargetpos = 4
	elseif targetpos == 5 then
		target_x = 142
		target_y= 116
		lasttargetpos = 5
	elseif targetpos == 6 then
		target_x = 314
		target_y= 116
		lasttargetpos = 6
	elseif targetpos == 7 then
		target_x = 363
		target_y= 116
		lasttargetpos = 7
	elseif targetpos == 8 then
		target_x = 57
		target_y= 213
		lasttargetpos = 8
	elseif targetpos == 9 then
		target_x = 228
		target_y= 213
		lasttargetpos = 9
	elseif targetpos == 10 then
		target_x = 436
		target_y= 176
		lasttargetpos = 10
	end
end

function drawgameover()
	screen:fillRect(127, 57, 226, 143, white) -- Game Over Square
	screen:print(180, 62, "G A M E  O V E R", blue1)
	screen:print(210, 102, "Score: "..score, blue1)
	screen:print(160, 182, "Press X for New Game", blue1)
end

-- main loop
while true do

	if screenid == 0 then -- Main Menu

		for i=0,1 do
			keyboardControl()
		end
		screen:blit(0, 0, background, 0, 0, background:width(), background:height(), false)
		if menuitem == 0 then
			screen:print(205, 100, "Start Game <", white)
			screen:print(220, 120, "About", blue2)
		elseif menuitem == 1 then
			screen:print(205, 100, "Start Game", blue2)
			screen:print(220, 120, "About <", white)
		end
		screen:print(10, 240, "v0.1", white)
		if go == 1 then
			if menuitem == 0 then
				go = 0
				screenid = 1
				settarget()
			elseif menuitem == 1 then
				go = 0
				screenid = 2
			end
		end
		screen.flip()
		screen.waitVblankStart(6)
		menuchange = 0

	elseif screenid == 1  then -- Game

		if state == 0 then -- Game is in the Normal State
			for i=0,4 do
				keyboardControl()
			end
			move()
			drawgame()
			checkcollisions()
			screen.flip()
			if statechange == 1 then
				screen.waitVblankStart(20)
				statechange = 0
			end
		elseif state == 1 then -- Game is in the Paused State
			for i=0,4 do
				keyboardControl()
			end
			drawgame()
			screen:print(380, 259, "P A U S E D", blue1)
			screen.flip()
			if statechange == 1 then
				screen.waitVblankStart(20)
				statechange = 0
			end
		elseif state == 2 then -- Game is in the Game Over State
			for i=0,4 do
				keyboardControl()
			end
			drawgame()
			drawgameover()
			screen.flip()
			if statechange == 1 then
				screen.waitVblankStart(20)
				statechange = 0
			end
		end

	elseif screenid == 2 then -- About Screen

		for i=0,1 do
			keyboardControl()
		end
		screen:blit(0, 0, background, 0, 0, background:width(), background:height(), false)
		screen:print(205, 23, "by MasterQ", white)
		screen:print(10, 30, "__________________________________________________________", blue2)
		screen:print(10, 40, "SlammerBall is based off of the PC game 'SlammerBall' made", white)
		screen:print(10, 50, "by me a few years ago. The PSP version was completely", white)
		screen:print(10, 60, "re-coded from scratch (not to mention in a different", white)
		screen:print(10, 70, "programming language).", white)
		screen:print(10, 90, "__________________________________________________________", blue2)
		screen:print(10, 103, "Instructions:", white)
		screen:print(10, 110, "__________________________________________________________", blue2)
		screen:print(10, 120, "You are the SlammerBall, and you have to collect the green", white)
		screen:print(10, 130, "targets while avoiding the outside walls and obstacles.", white)
		screen:print(10, 140, "Also, once you start moving, you can change directions,", white)
		screen:print(10, 150, "but you can't stop.", white)
		screen:print(10, 240, "Press O to return to the Main Menu.", white)
		screen.flip()

	end
end
